<!--- 
The contents of this file are subject to the Mozilla Public License Version 1.1
(the "License"); you may not use this file except in compliance with the
License. You may obtain a copy of the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is comprised of the PT Multimedia directory

The Initial Developer of the Original Code is
PaperThin, Inc. Copyright(C) 2012.
All Rights Reserved.

By downloading, modifying, distributing, using and/or accessing any files 
in this directory, you agree to the terms and conditions of the applicable 
end user license agreement.
--->

<!---
/* *************************************************************** */
Author: 	
	PaperThin Inc.
Name:
	multimedia_rh.cfm
ADF App:
	PT Multimedia
Version:
	2.0
History:
	2010-08-20 - DMB - Created
	2012-09-06 - MFC - Updated to load the App Style CSS.
					   Removed load JQuery version to load from the ADF default.
					   Adjusted the formatting for the file.
					   Updated to make styles unique for the app.
	2012-09-10 - MFC - Updated html with DIV clears for CS Work Mode spacing.
	02-01-2013 - DMB - Fixed rendering of youtube videos in the lightbox when using the shortened url.
	02-06-2013 - DMB - Fixed the unordered list rendering for the 3-row videos.
	03-05-2013 - DMB - Modified to enable compatibility with the Multimedia Element as well as the category gallery and series gallery elements.
						 		  -.Fixed a significant number of issues running under Railo.
--->
<cfscript>
	// Load jQuery
	application.ptMultiMedia.scripts.loadJQuery();
	application.ptMultiMedia.scripts.loadADFLightbox();
	request.element.isStatic = 0;
 	// items = arrayNew(1);
	criteria = attributes.elementInfo.elementData.propertyValues;
	// application.ADF.utils.dodump(criteria, "criteria", false);
</cfscript>
<cfparam name="items" default="">
<cfoutput>
	<!--- Load the Styles --->
	<link rel="stylesheet" href="/ADF/apps/pt_multimedia/style/ptmultimedia.css" type="text/css" >
</cfoutput>
<cftry>   
	<cfscript>
		//	application.ADF.utils.dodump(criteria, "criteria", false);
		// determine if limited to featured items
		if (structKeyExists(criteria[1].values,	"featuredOnly")) {	
		    switch(criteria[1].values.featuredOnly)
		    {
				case "Display Featured":
				{
				     featured = "Yes";
				     break;
				}
				case "Display Not Featured":
				{
				     featured = "No";
				     break;
				}
				case "Display All":
				{
				     featured = "";
				     break;
				}
				default:
				{
				     featured = "";
				     break;
				}
		    }
		}  
		// determine how many items to display
	if (structKeyExists(criteria[1].values,	"records")) {	
			switch(criteria[1].values.records)
			{
				case "1":
				{
				     records = "1";
				     break;
				}
				case "3":
				{
				     records = "3";
				     break;
				}
				case "Display All":
				{
				     records = "-1";
				     break;
				}
				default:
				{
				     records = "-1";
				     break;
				}
			} 
	} 
		 // determine sort order
	if (structKeyExists(criteria[1].values,	"orderedby")) {
			switch(criteria[1].values.orderedby)
			{
				case "Release Date":
				{
				     orderedby = "releaseDate Desc";
				     break;
				}
				case "Title":
				{
				     Orderedby = "title asc";
				     break;
				}
				default:
				{
				     Orderedby = "releaseDate Desc";
				     break;
				}
			} 
	}
		if (structkeyexists(criteria[1].values,"categorySelect") and (len(criteria[1].values.categoryselect))){
			// Find records that belong to our category
			items = application.ptmultimedia.mediaDAO.getByCategoryID(criteria[1].values.categoryselect,#records#,"#featured#",#Orderedby#);
		}
		else {
			if (structkeyexists(criteria[1].values,"seriesSelect") and (len(criteria[1].values.seriesSelect))){
				// Find records that belong to our series
				items = application.ptmultimedia.mediaDAO.getBySeriesID(criteria[1].values.seriesSelect,#records#,"#featured#",#Orderedby#);
			}
		}
	</cfscript>
  <!--- if we don't have any records then this must be the multimedia element and not the multimedia category element   --->
  <cfif not isArray(items)>  
	<cfset items = criteria>
	<cfset records = arraylen(items)>
 </cfif> 
  	<cfcatch>
		<cfoutput><br />If using the Multimedia Category Gallery Element or Multimedia Series Gallery Element on this page, please choose the item(s) to display.  If using the Multimedia Element on this page, please set a render mode filter for items to display.<cfexit><br /><br /></cfoutput>
	</cfcatch>
</cftry>   
<!-- hack to fix embedcode which was missing from view results --->
<cftry>
	<cfloop index="z" from="1" to="#Arraylen(items)#">
		<cfif not items[z].values.hostSelect is "local">
			<cfif items[z].values.embedcode is "">
					<cfscript>
						thisid = application.ptmultimedia.cedata.getCEData("multiMedia", "id", items[z].values.id, "selected");
						items[z].values.embedcode = thisid[1].values.embedcode;
					</cfscript>
			</cfif>
		</cfif>
	</cfloop>

	<cfcatch>
		<cfoutput><br />Please select a Series or Category for which to display results.</cfoutput><cfexit>
	</cfcatch>
</cftry>
<cfscript>
	//  Get metadata that dictates how output will be displayed
	displayStruct =attributes.elementInfo.RenderHandlerMetaData;
	
	// Config - Media upload destination path	
	if ( (StructKeyExists(server.ADF.environment[request.site.id].ptMultimedia, "popUPPlayerURL")) AND (LEN(server.ADF.environment[request.site.id].ptMultimedia.popUPPlayerURL)) ) {
		popUPPlayerURL = server.ADF.environment[request.site.id].ptMultimedia.popUPPlayerURL;
	}
	else {
		popUPPlayerURL = "";
	}
</cfscript>
<!--- verify that the user has selected a display format ---> 
<cfif StructIsEmpty(displayStruct)>
	<cfoutput><div>Please select Edit Metadata for the element and choose a display format</div></cfoutput> 
	<cfexit>
</cfif>
<cfif NOT ArrayLen(items)>
	<cfoutput><div>No records matched the filter criteria</div></cfoutput>
<cfelse>
<cfoutput><div style="clear:both;"></div></cfoutput>
	<!---  //                                                  --->
	<!---  //  S I N G L E  F E A T U R E D  V I D E O         --->
	<!--- //                                                   --->
	<cfif displayStruct.MultimediaDisplayFormat.displayFormat is "Featured Video">
		<cfoutput>
			<cfif items[1].values.hostSelect is "local">
				<!--- //  L O C A L L Y  H O S T E D --->
				<div id="ptmultimedia-outercontainer">
					<!--- <h1 align="center" class="header" id="header">Social Media Center</h1><br>&nbsp; --->
					<div id="ptmultimedia-leftcontainer">
						<cfscript>
								// render the player	
								 application.ptmultiMedia.mediaService.mediaPlayer("#items[1].values.id#");
						</cfscript>
						<br>&nbsp;<br>
					</div>
					<div id="ptmultimedia-rightcontainer">
							<h3 align="center">Featured Video</h1><br>
							#items[1].values.description#
					</div>
				</div>
			<cfelse>
		 		<!--- //  E X T E R N A L  V I D E O  --->
				<cfscript>
					// Parse the video embed code into a struct
					videoStruct = application.ptmultiMedia.mediaRenderService.parseEmbed("#items[1].values.embedcode#","#items[1].values.id#");
					// generate the lightbox script
					LBStruct 	= application.ptmultiMedia.mediaService.LBmediaPlayerJS("#items[1].values.id#");
					Writeoutput(#LBStruct.LBscript#);
				</cfscript>
					<div id="ptmultimedia-outercontainer">
						<!--- <h1 align="center" class="header" id="header">Social Media Center</h1><br>&nbsp; --->
						<div id="ptmultimedia-leftcontainer">			
									<a href="javascript:;" onClick="doOnClick#LBStruct.unique#()"><img src="#videoStruct.bigthumb#" height="200" width="260" border="0"</a>
							<br>&nbsp;<br>
						</div>
						<div id="ptmultimedia-rightcontainer">
								<h3 align="center">Featured Video</h1><br>
								#items[1].values.description#
						</div>
					</div>
			</cfif>
		</cfoutput>
	</cfif>
	<!---  //                                                      --->
	<!---  //  L I N K L I S T  O F   R E L A T E D  V I D E O S   --->
	<!--- //                                                       --->
	<cfif displayStruct.MultimediaDisplayFormat.displayFormat is "Related Videos">
	<cfparam name="counter" default="0">
		<cfoutput>
		<br><h3>Related Videos</h3><br>&nbsp;
		 <cfloop index="i" from="1" to="#Arraylen(items)#">
		<cfif  ((isStruct(items[i].values.previewimage)) and (structkeyexists(items[i].values.previewimage, "resolvedURL")) and (structkeyexists(items[i].values.previewimage.resolvedURL, "serverRelative")))>
				<cfset CPIMAGE = items[i].values.previewimage.resolvedURL.serverRelative>
				<cfset previewimage = CPIMAGE> 
		<cfelseif items[i].values.previewimage contains "CPIMAGE">
						<cfset CPIMAGE = application.ADF.csData.decipherCPIMAGE(items[i].values.previewimage)>
						<cfset previewimage = CPIMAGE.resolvedURL.serverRelative>
		<cfelse>
				<cfset previewimage = "">
		</cfif> 
	 	<cfif items[1].values.hostSelect is "local">
				<cfset LBStruct 	= application.ptmultiMedia.mediaService.LBmediaPlayerJS("#items[i].values.id#")>
				#LBStruct.LBscript#
				<br><a href="javascript:;" onclick="doOnClick#LBStruct.unique#()">#items[i].values.title#</a>&nbsp;&nbsp;-&nbsp;&nbsp;#items[i].values.caption#
		<cfelse>
		<!--- //  E X T E R N A L  V I D E O  --->
				<cfscript>
					// Parse the video embed code into a struct
					videoStruct = application.ptmultiMedia.mediaRenderService.parseEmbed("#items[i].values.embedcode#","#items[i].values.id#");
					// generate the lightbox script
					LBStruct 	= application.ptmultiMedia.mediaService.LBmediaPlayerJS("#items[i].values.id#");
					Writeoutput(#LBStruct.LBscript#);
			  </cfscript>
			<br><a href="javascript:;" onclick="doOnClick#LBStruct.unique#()">#items[i].values.title#</a>&nbsp;&nbsp;-&nbsp;&nbsp;#items[i].values.caption#
		</cfif>
		</cfloop>
		<br>&nbsp; 
		</cfoutput>
		<CFMODULE TEMPLATE="/commonspot/utilities/ct-render-named-element.cfm"
		ElementName="AllVideosLink"
	          ElementType="link">
	</cfif>
	<!---  //                                                                --->
	<!---  //  S I N G L E  V E R T I C A L  C O L U M N  O F  T H U M B S   --->
	<!--- //                                                                 --->		
	<cfif displayStruct.MultimediaDisplayFormat.displayFormat is "1 Column Vertical">
		<cfoutput>
			<cfloop index="i" from="1" to="#Arraylen(items)#">
				 <cfif  ((isStruct(items[i].values.previewimage)) and (structkeyexists(items[i].values.previewimage, "resolvedURL")) and (structkeyexists(items[i].values.previewimage.resolvedURL, "serverRelative")))>
						<cfset CPIMAGE = items[i].values.previewimage.resolvedURL.serverRelative>
						<cfset previewimage = CPIMAGE> 
				<cfelseif items[i].values.previewimage contains "CPIMAGE">
								<cfset CPIMAGE = application.ADF.csData.decipherCPIMAGE(items[i].values.previewimage)>
								<cfset previewimage = CPIMAGE.resolvedURL.serverRelative>
				<cfelse>
						<cfset previewimage = "">
				</cfif>
				<cfif items[i].values.hostSelect is "local">
					<cfset LBStruct 	= application.ptmultiMedia.mediaService.LBmediaPlayerJS("#items[i].values.id#")>
					#LBStruct.LBscript#
					<br>&nbsp;<br>&nbsp;<br>
					<div style="float: left; margin-right: 3px;"> 
					<a href="javascript:;" onClick="doOnClick#LBStruct.unique#()"> 
						<cfif trim(previewimage) is "">
							<img src="/ADF/apps/pt_multimedia/images/noimage.gif" alt="" width="139" height="93" border="0">
						<cfelse>
							<img src="#previewimage#" alt="" border="0" width="139" height="93" >
						</cfif>
					</a>
					</div>
					<span class="ptmultimedia-vidicon" id="ptmultimedia-vidicon">&nbsp;</span>
					<div class="ptmultimedia-oncolumnvidright">
							<a href="javascript:;" onclick="doOnClick#LBStruct.unique#()">#items[i].values.title#</a><br>
							#items[i].values.caption#<br>
					</div>
					<div class="clear">&nbsp;</div>
				<cfelse>
						<!--- //  E X T E R N A L  V I D E O  --->
						<cfscript>
							// Parse the video embed code into a struct
							videoStruct = application.ptmultiMedia.mediaRenderService.parseEmbed("#items[i].values.embedcode#","#items[i].values.id#");
							// generate the lightbox script
							LBStruct 	= application.ptmultiMedia.mediaService.LBmediaPlayerJS("#items[i].values.id#");
							Writeoutput(#LBStruct.LBscript#);
					  </cfscript>
							<br>&nbsp;<br>
						<div style="float: left; margin-right: 3px;"> 
						<a href="javascript:;" onClick="doOnClick#LBStruct.unique#()"><img src="#VideoStruct.smallthumb#" height="90" width="120" border="0"> 					</a>
						</div>
						<span class="ptmultimedia-vidicon" id="ptmultimedia-vidicon">&nbsp;</span>
						<div class="ptmultimedia-oncolumnvidright">
								<a href="javascript:;" onclick="doOnClick#LBStruct.unique#()">#items[i].values.title#</a><br>
								#items[i].values.caption#<br>
						</div>
						<div class="clear">&nbsp;</div>
				</cfif>
			</cfloop>
		</cfoutput>
	</cfif>
	<!---  //                                                  --->
	<!---  //  R E N D E R S  R O W  O F  3  T H U M B S       --->
	<!--- //                                                   --->				
	<cfif displayStruct.MultimediaDisplayFormat.displayFormat is "Row of 3 thumbs">
			<cfoutput>
			<div id="ptmultimedia-media-list" class="ptmultimedia-media-list">
			 <cfset loopcount=0>
			<cfif ArrayLen(items)>
					<cfloop from="1" to="#ArrayLen(items)#" index="i">
						<cfif items[i].values.hostSelect is "local">
								<!--- // insures that we never exceed 3 items --->
								<cfif (((loopcount mod 3)  is 0) AND (loopcount neq 1))>
									</ul><ul>
								</cfif>
			<cfset loopcount = loopcount+1>				
								<cfset currentFormID = attributes.elementinfo.elementparams.properties.formid>									
								<cfif  ((isStruct(items[i].values.previewimage)) and (structkeyexists(items[i].values.previewimage, "resolvedURL")) and (structkeyexists(items[i].values.previewimage.resolvedURL, "serverRelative")))>
										<cfset CPIMAGE = items[i].values.previewimage.resolvedURL.serverRelative>
										<cfset previewimage = CPIMAGE> 
								<cfelseif items[i].values.previewimage contains "CPIMAGE">
												<cfset CPIMAGE = application.ADF.csData.decipherCPIMAGE(items[i].values.previewimage)>
												<cfset previewimage = CPIMAGE.resolvedURL.serverRelative>
								<cfelse>
										<cfset previewimage = "">
								</cfif>
								<cfset LBStruct 	= application.ptmultiMedia.mediaService.LBmediaPlayerJS("#items[i].values.id#")>						
								<!--- render the lightbox script --->
								#LBStruct.LBscript#		
							    		<li>
							            <div class="ptmultimedia-formats"><a href="javascript:;" onclick="doOnClick#LBStruct.unique#()" class="#lcase(items[i].values.type)#"></a></div>
							  		        <div class="release-date">#dateformat(items[i].values.releasedate, "mm/dd/yyyy")#</div>
												<a href="javascript:;" onclick="doOnClick#LBStruct.unique#()">
	
											<cfif trim(previewimage) is "">
												<img src="/ADF/apps/pt_multimedia/images/noimage.gif" alt="" width="139" height="93" border="0">
											<cfelse>
												<img src="#previewimage#" alt="" border="0" width="139" height="93" >
											</cfif>
											</a>
							  		        <p>#items[i].values.caption#</p>
							        </li>
						<cfelse>
						<!--- E X T E R N A L  V I D E O --->
									<!--- // insures that we never exceed 3 items --->
									<cfif ((loopcount mod 3)  is 0)>
										</ul><ul>
									 </cfif>
									<cfset loopcount = loopcount+1>
									<cfscript>
										// Parse the video embed code into a struct
										videoStruct = application.ptmultiMedia.mediaRenderService.parseEmbed("#items[i].values.embedcode#","#items[i].values.id#");
										// generate the lightbox script
										LBStruct 	= application.ptmultiMedia.mediaService.LBmediaPlayerJS("#items[i].values.id#");
										Writeoutput(#LBStruct.LBscript#);
								  </cfscript>
									<!--- render the lightbox script --->
									#LBStruct.LBscript#
						      		<li>
						            <div class="ptmultimedia-formats">
									<a href="javascript:;" onclick="doOnClick#LBStruct.unique#()" class="#lcase(items[i].values.type)#">#items[i].values.type#</a></div>
						  		        <div class="release-date">#dateformat(items[i].values.releasedate, "mm/dd/yyyy")#</div>
											<a href="javascript:;" onClick="doOnClick#LBStruct.unique#()"><img src=" #VideoStruct.smallthumb#" height="90" width="120" border="0"></a>
						  		        <p>#items[i].values.caption#</p>
							        </li>  
						</cfif>								
					</cfloop>
						<!--- handle situation where there may be less than 3 results --->
				<cfif NOT ((loopcount mod 3)  is 0)>
						<cfloop from="1" to="3" index="i">
									<li>
							            <div class="ptmultimedia-formats">&nbsp;</div>
							  		        <div class="release-date">&nbsp;</div>
							  		         <p>&nbsp;</p>
							        </li>
									<cfset loopcount = loopcount+1>
								<cfif ((loopcount mod 3)  is 0)>
								</ul>
								<cfbreak>
								</cfif>
							</cfloop>
					</cfif>	 		
		</cfif>	
		</div>
		</cfoutput>
	</cfif>
	<!---  //                                                  --->
	<!---  //  R E N D E R S  S I N G L E   T H U M B          --->
	<!--- //                                                   --->				
	<cfif displayStruct.MultimediaDisplayFormat.displayFormat is "Single Thumb">
			<cfif  ((isStruct(items[1].values.previewimage)) and (structkeyexists(items[1].values.previewimage, "resolvedURL")) and (structkeyexists(items[1].values.previewimage.resolvedURL, "serverRelative")))>
					<cfset CPIMAGE = items[1].values.previewimage.resolvedURL.serverRelative>
					<cfset previewimage = CPIMAGE> 
			<cfelseif items[1].values.previewimage contains "CPIMAGE">
							<cfset CPIMAGE = application.ADF.csData.decipherCPIMAGE(items[1].values.previewimage)>
							<cfset previewimage = CPIMAGE.resolvedURL.serverRelative>
			<cfelse>
					<cfset previewimage = "">
			</cfif>
			<cfif items[1].values.hostSelect is "local">
						<cfset LBStruct 	= application.ptmultiMedia.mediaService.LBmediaPlayerJS("#items[1].values.id#")>
						<cfoutput>
						<!--- render the lightbox script --->
						#LBStruct.LBscript#
						<br>&nbsp;<br><br>&nbsp;<br>
						<a href="javascript:;" onclick="doOnClick#LBStruct.unique#()">
							<cfif trim(previewimage) is "">
								<img src="/ADF/apps/pt_multimedia/images/noimage.gif" alt="" width="139" height="93" border="0">
							<cfelse>
								<img src="#previewimage#" alt="" border="0" width="139" height="93" >
							</cfif>
							</a>
						</cfoutput>
			<cfelse>
						<!--- //  E X T E R N A L  V I D E O  --->
						<cfscript>
							// Parse the video embed code into a struct
							videoStruct = application.ptmultiMedia.mediaRenderService.parseEmbed("#items[1].values.embedcode#","#items[1].values.id#");
							// generate the lightbox script
							LBStruct 	= application.ptmultiMedia.mediaService.LBmediaPlayerJS("#items[1].values.id#");
							Writeoutput(#LBStruct.LBscript#);
					  </cfscript>
					 
					  <cfoutput>
					  <br>&nbsp;<br><br>&nbsp;<br>
					  <a href="javascript:;" onclick="doOnClick#LBStruct.unique#()">
								<img src="#VideoStruct.smallthumb#" alt="" border="0" width="139" height="93" >
					 </a>
					</cfoutput>
			</cfif>
	</cfif>
	<!---  //                                                                --->
	<!---  //  Audio Link  													 --->
	<!--- //                                                                 --->		
	<cfif displayStruct.MultimediaDisplayFormat.displayFormat is "Audio Link">
			<cfset LBStruct 	= application.ptmultiMedia.mediaService.LBmediaPlayerJS("#items[1].values.id#")>
			<cfoutput>
			<!--- render the lightbox script --->
			#LBStruct.LBscript#
			<br>&nbsp;<br><br>&nbsp;<br>
			<a href="javascript:;" onclick="doOnClick#LBStruct.unique#()">#items[1].values.caption#</a>
			</cfoutput>
	</cfif>
	<!---  //                                                                --->
	<!---  //  Audio Player													 --->
	<!--- //                                                                 --->		
	<cfif displayStruct.MultimediaDisplayFormat.displayFormat is "Audio Player">			
						<br>&nbsp;<br>
						<cfscript>
								// render the player	
								application.ptmultiMedia.mediaService.mediaPlayer("#items[1].values.id#");
						</cfscript>
						<br>&nbsp;<br>
						#items[1].values.description#
	</cfif>
</cfif>
<cfoutput>
	<div style="clear:both;"></div>
</cfoutput>